
package de.ivu.elect.was.exchange.ergebnis;

import static java.util.Arrays.asList;

import java.util.Collection;

import javax.inject.Inject;

import de.ivu.elect.business.ergebnis.boundary.NlWasModelP222BulkExporter;
import de.ivu.elect.business.security.Customer;
import de.ivu.elect.business.stimmeingabe.entity.Ergebniseingabestatus;
import de.ivu.elect.business.wahl.entity.NlWahlart;
import de.ivu.elect.business.wahl.entity.Wahl;
import de.ivu.elect.was.exchange.ergebnis.eml.AbstractNlWasEml5xxNachGebietErgebniseingabestatusExportMapper;
import de.ivu.elect.was.exchange.ergebnis.eml.Eml520ErgebnisExportMapper;

/**
 * @see NlWasModelP222MainDocumentExportMapper
 */
public class NlWasModelP222Eml520ExportMapper extends AbstractNlWasEml5xxNachGebietErgebniseingabestatusExportMapper implements NlWasModelP222ExportMapper {

  @Inject
  private transient Eml520ErgebnisExportMapper eml520ErgebnisExportMapper;

  public NlWasModelP222Eml520ExportMapper() {
    super();
  }

  @Override // https://support.elect-it.com/wiki/x/48g8
  protected Collection<NlWahlart> collectWahlartenAccepted() {
    return asList( //
        NlWahlart.PROVINCIALE_STATEN1, //
        NlWahlart.GEMEENTERAAD //
    );
  }

  @Override // https://support.elect-it.com/wiki/x/48g8
  protected boolean isAcceptWahlebene(Wahl wahl, Customer customer) {
    return NlWahlart.isWasCSB(wahl, customer);
  }

  @Override
  protected Collection<Ergebniseingabestatus> collectErgebniseingabestatusAccepted() {
    return NlWasModelP222BulkExporter.EXPORT_ERGEBNISEINGABESTATUS;
  }

  @Override
  protected Eml520ErgebnisExportMapper getEmlExportMapper() {
    return eml520ErgebnisExportMapper;
  }
}
